from __future__ import annotations

from arch.univariate import recursions_python
from arch.univariate.distribution import (
    Distribution,
    GeneralizedError,
    Normal,
    SkewStudent,
    StudentsT,
)
from arch.univariate.mean import ARX, HARX, LS, ConstantMean, ZeroMean, arch_model
from arch.univariate.volatility import (
    APARCH,
    ARCH,
    EGARCH,
    FIGARCH,
    GARCH,
    HARCH,
    ConstantVariance,
    EWMAVariance,
    FixedVariance,
    MIDASHyperbolic,
    RiskMetrics2006,
)

try:
    from arch.univariate import recursions
except ImportError:
    recursions = recursions_python

__all__ = [
    "HARX",
    "ConstantMean",
    "ZeroMean",
    "ARX",
    "arch_model",
    "LS",
    "GARCH",
    "APARCH",
    "ARCH",
    "HARCH",
    "ConstantVariance",
    "EWMAVariance",
    "RiskMetrics2006",
    "EGARCH",
    "Distribution",
    "Normal",
    "StudentsT",
    "SkewStudent",
    "GeneralizedError",
    "FixedVariance",
    "MIDASHyperbolic",
    "FIGARCH",
    "recursions",
    "recursions_python",
]
